---
title: Get a notebook
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Notebooks
---

# Get a notebook{% #get-a-notebook %}

{% tab title="v1" %}

| Datadog site      | API endpoint                                                     |
| ----------------- | ---------------------------------------------------------------- |
| ap1.datadoghq.com | GET https://api.ap1.datadoghq.com/api/v1/notebooks/{notebook_id} |
| ap2.datadoghq.com | GET https://api.ap2.datadoghq.com/api/v1/notebooks/{notebook_id} |
| app.datadoghq.eu  | GET https://api.datadoghq.eu/api/v1/notebooks/{notebook_id}      |
| app.ddog-gov.com  | GET https://api.ddog-gov.com/api/v1/notebooks/{notebook_id}      |
| us2.ddog-gov.com  | GET https://api.us2.ddog-gov.com/api/v1/notebooks/{notebook_id}  |
| app.datadoghq.com | GET https://api.datadoghq.com/api/v1/notebooks/{notebook_id}     |
| us3.datadoghq.com | GET https://api.us3.datadoghq.com/api/v1/notebooks/{notebook_id} |
| us5.datadoghq.com | GET https://api.us5.datadoghq.com/api/v1/notebooks/{notebook_id} |

### Overview

Get a notebook using the specified notebook ID. This endpoint requires the `notebooks_read` permission.

### Arguments

#### Path Parameters

| Name                          | Type    | Description                                       |
| ----------------------------- | ------- | ------------------------------------------------- |
| notebook_id [*required*] | integer | Unique ID, assigned when you create the notebook. |

### Response

{% tab title="200" %}
OK
{% tab title="Model" %}
The description of a notebook response.

| Parent field              | Field                              | Type                | Description                                                                                                                                                                                                                                                                                                                           |
| ------------------------- | ---------------------------------- | ------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
|                           | data                               | object              | The data for a notebook.                                                                                                                                                                                                                                                                                                              |
| data                      | attributes [*required*]       | object              | The attributes of a notebook.                                                                                                                                                                                                                                                                                                         |
| attributes                | author                             | object              | Attributes of user object returned by the API.                                                                                                                                                                                                                                                                                        |
| author                    | created_at                         | date-time           | Creation time of the user.                                                                                                                                                                                                                                                                                                            |
| author                    | disabled                           | boolean             | Whether the user is disabled.                                                                                                                                                                                                                                                                                                         |
| author                    | email                              | string              | Email of the user.                                                                                                                                                                                                                                                                                                                    |
| author                    | handle                             | string              | Handle of the user.                                                                                                                                                                                                                                                                                                                   |
| author                    | icon                               | string              | URL of the user's icon.                                                                                                                                                                                                                                                                                                               |
| author                    | name                               | string              | Name of the user.                                                                                                                                                                                                                                                                                                                     |
| author                    | status                             | string              | Status of the user.                                                                                                                                                                                                                                                                                                                   |
| author                    | title                              | string              | Title of the user.                                                                                                                                                                                                                                                                                                                    |
| author                    | verified                           | boolean             | Whether the user is verified.                                                                                                                                                                                                                                                                                                         |
| attributes                | cells [*required*]            | [object]            | List of cells to display in the notebook.                                                                                                                                                                                                                                                                                             |
| cells                     | attributes [*required*]       |  <oneOf>       | The attributes of a notebook cell response. Valid cell types are `markdown`, `timeseries`, `toplist`, `heatmap`, `distribution`, `log_stream`. [More information on each graph visualization type.](https://docs.datadoghq.com/dashboards/widgets.md)                                                                                 |
| attributes                | Option 1                           | object              | The attributes of a notebook `markdown` cell.                                                                                                                                                                                                                                                                                         |
| Option 1                  | definition [*required*]       | object              | Text in a notebook is formatted with [Markdown](https://daringfireball.net/projects/markdown/), which enables the use of headings, subheadings, links, images, lists, and code blocks.                                                                                                                                                |
| definition                | text [*required*]             | string              | The markdown content.                                                                                                                                                                                                                                                                                                                 |
| definition                | type [*required*]             | enum                | Type of the markdown cell. Allowed enum values: `markdown`                                                                                                                                                                                                                                                                            |
| attributes                | Option 2                           | object              | The attributes of a notebook `timeseries` cell.                                                                                                                                                                                                                                                                                       |
| Option 2                  | definition [*required*]       | object              | The timeseries visualization allows you to display the evolution of one or more metrics, log events, or Indexed Spans over time.                                                                                                                                                                                                      |
| definition                | custom_links                       | [object]            | List of custom links.                                                                                                                                                                                                                                                                                                                 |
| custom_links              | is_hidden                          | boolean             | The flag for toggling context menu link visibility.                                                                                                                                                                                                                                                                                   |
| custom_links              | label                              | string              | The label for the custom link URL. Keep the label short and descriptive. Use metrics and tags as variables.                                                                                                                                                                                                                           |
| custom_links              | link                               | string              | The URL of the custom link. URL must include `http` or `https`. A relative URL must start with `/`.                                                                                                                                                                                                                                   |
| custom_links              | override_label                     | string              | The label ID that refers to a context menu link. Can be `logs`, `hosts`, `traces`, `profiles`, `processes`, `containers`, or `rum`.                                                                                                                                                                                                   |
| definition                | description                        | string              | The description of the widget.                                                                                                                                                                                                                                                                                                        |
| definition                | events                             | [object]            | **DEPRECATED**: List of widget events. Deprecated - Use `overlay` request type instead.                                                                                                                                                                                                                                               |
| events                    | q [*required*]                | string              | Query definition.                                                                                                                                                                                                                                                                                                                     |
| events                    | tags_execution                     | string              | The execution method for multi-value filters.                                                                                                                                                                                                                                                                                         |
| definition                | legend_columns                     | [string]            | Columns displayed in the legend.                                                                                                                                                                                                                                                                                                      |
| definition                | legend_layout                      | enum                | Layout of the legend. Allowed enum values: `auto,horizontal,vertical`                                                                                                                                                                                                                                                                 |
| definition                | legend_size                        | string              | Available legend sizes for a widget. Should be one of "0", "2", "4", "8", "16", or "auto".                                                                                                                                                                                                                                            |
| definition                | markers                            | [object]            | List of markers.                                                                                                                                                                                                                                                                                                                      |
| markers                   | display_type                       | string              | Combination of:                                                                                                                                                                                                                                                                                                                       |
| markers                   | label                              | string              | Label to display over the marker.                                                                                                                                                                                                                                                                                                     |
| markers                   | time                               | string              | Timestamp for the widget.                                                                                                                                                                                                                                                                                                             |
| markers                   | value [*required*]            | string              | Value to apply. Can be a single value y = 15 or a range of values 0 < y < 10. For Distribution widgets with `display_type` set to `percentile`, this should be a numeric percentile value (for example, "90" for P90).                                                                                                                |
| definition                | requests [*required*]         | [object]            | List of timeseries widget requests.                                                                                                                                                                                                                                                                                                   |
| requests                  | apm_query                          | object              | **DEPRECATED**: Deprecated - Use `queries` and `formulas` instead.                                                                                                                                                                                                                                                                    |
| apm_query                 | compute                            | object              | Define computation for a log query.                                                                                                                                                                                                                                                                                                   |
| compute                   | aggregation [*required*]      | string              | The aggregation method.                                                                                                                                                                                                                                                                                                               |
| compute                   | facet                              | string              | Facet name.                                                                                                                                                                                                                                                                                                                           |
| compute                   | interval                           | int64               | Define a time interval in seconds.                                                                                                                                                                                                                                                                                                    |
| apm_query                 | group_by                           | [object]            | List of tag prefixes to group by in the case of a cluster check.                                                                                                                                                                                                                                                                      |
| group_by                  | facet [*required*]            | string              | Facet name.                                                                                                                                                                                                                                                                                                                           |
| group_by                  | limit                              | int64               | Maximum number of items in the group.                                                                                                                                                                                                                                                                                                 |
| group_by                  | sort                               | object              | Define a sorting method.                                                                                                                                                                                                                                                                                                              |
| sort                      | aggregation [*required*]      | string              | The aggregation method.                                                                                                                                                                                                                                                                                                               |
| sort                      | facet                              | string              | Facet name.                                                                                                                                                                                                                                                                                                                           |
| sort                      | order [*required*]            | enum                | Widget sorting methods. Allowed enum values: `asc,desc`                                                                                                                                                                                                                                                                               |
| apm_query                 | index                              | string              | A coma separated-list of index names. Use "*" query all indexes at once. [Multiple Indexes](https://docs.datadoghq.com/logs/indexes.md#multiple-indexes)                                                                                                                                                                              |
| apm_query                 | multi_compute                      | [object]            | This field is mutually exclusive with `compute`.                                                                                                                                                                                                                                                                                      |
| multi_compute             | aggregation [*required*]      | string              | The aggregation method.                                                                                                                                                                                                                                                                                                               |
| multi_compute             | facet                              | string              | Facet name.                                                                                                                                                                                                                                                                                                                           |
| multi_compute             | interval                           | int64               | Define a time interval in seconds.                                                                                                                                                                                                                                                                                                    |
| apm_query                 | search                             | object              | The query being made on the logs.                                                                                                                                                                                                                                                                                                     |
| search                    | query [*required*]            | string              | Search value to apply.                                                                                                                                                                                                                                                                                                                |
| requests                  | audit_query                        | object              | **DEPRECATED**: Deprecated - Use `queries` and `formulas` instead.                                                                                                                                                                                                                                                                    |
| audit_query               | compute                            | object              | Define computation for a log query.                                                                                                                                                                                                                                                                                                   |
| compute                   | aggregation [*required*]      | string              | The aggregation method.                                                                                                                                                                                                                                                                                                               |
| compute                   | facet                              | string              | Facet name.                                                                                                                                                                                                                                                                                                                           |
| compute                   | interval                           | int64               | Define a time interval in seconds.                                                                                                                                                                                                                                                                                                    |
| audit_query               | group_by                           | [object]            | List of tag prefixes to group by in the case of a cluster check.                                                                                                                                                                                                                                                                      |
| group_by                  | facet [*required*]            | string              | Facet name.                                                                                                                                                                                                                                                                                                                           |
| group_by                  | limit                              | int64               | Maximum number of items in the group.                                                                                                                                                                                                                                                                                                 |
| group_by                  | sort                               | object              | Define a sorting method.                                                                                                                                                                                                                                                                                                              |
| sort                      | aggregation [*required*]      | string              | The aggregation method.                                                                                                                                                                                                                                                                                                               |
| sort                      | facet                              | string              | Facet name.                                                                                                                                                                                                                                                                                                                           |
| sort                      | order [*required*]            | enum                | Widget sorting methods. Allowed enum values: `asc,desc`                                                                                                                                                                                                                                                                               |
| audit_query               | index                              | string              | A coma separated-list of index names. Use "*" query all indexes at once. [Multiple Indexes](https://docs.datadoghq.com/logs/indexes.md#multiple-indexes)                                                                                                                                                                              |
| audit_query               | multi_compute                      | [object]            | This field is mutually exclusive with `compute`.                                                                                                                                                                                                                                                                                      |
| multi_compute             | aggregation [*required*]      | string              | The aggregation method.                                                                                                                                                                                                                                                                                                               |
| multi_compute             | facet                              | string              | Facet name.                                                                                                                                                                                                                                                                                                                           |
| multi_compute             | interval                           | int64               | Define a time interval in seconds.                                                                                                                                                                                                                                                                                                    |
| audit_query               | search                             | object              | The query being made on the logs.                                                                                                                                                                                                                                                                                                     |
| search                    | query [*required*]            | string              | Search value to apply.                                                                                                                                                                                                                                                                                                                |
| requests                  | display_type                       | enum                | Type of display to use for the request. Allowed enum values: `area,bars,line,overlay`                                                                                                                                                                                                                                                 |
| requests                  | event_query                        | object              | **DEPRECATED**: Deprecated - Use `queries` and `formulas` instead.                                                                                                                                                                                                                                                                    |
| event_query               | compute                            | object              | Define computation for a log query.                                                                                                                                                                                                                                                                                                   |
| compute                   | aggregation [*required*]      | string              | The aggregation method.                                                                                                                                                                                                                                                                                                               |
| compute                   | facet                              | string              | Facet name.                                                                                                                                                                                                                                                                                                                           |
| compute                   | interval                           | int64               | Define a time interval in seconds.                                                                                                                                                                                                                                                                                                    |
| event_query               | group_by                           | [object]            | List of tag prefixes to group by in the case of a cluster check.                                                                                                                                                                                                                                                                      |
| group_by                  | facet [*required*]            | string              | Facet name.                                                                                                                                                                                                                                                                                                                           |
| group_by                  | limit                              | int64               | Maximum number of items in the group.                                                                                                                                                                                                                                                                                                 |
| group_by                  | sort                               | object              | Define a sorting method.                                                                                                                                                                                                                                                                                                              |
| sort                      | aggregation [*required*]      | string              | The aggregation method.                                                                                                                                                                                                                                                                                                               |
| sort                      | facet                              | string              | Facet name.                                                                                                                                                                                                                                                                                                                           |
| sort                      | order [*required*]            | enum                | Widget sorting methods. Allowed enum values: `asc,desc`                                                                                                                                                                                                                                                                               |
| event_query               | index                              | string              | A coma separated-list of index names. Use "*" query all indexes at once. [Multiple Indexes](https://docs.datadoghq.com/logs/indexes.md#multiple-indexes)                                                                                                                                                                              |
| event_query               | multi_compute                      | [object]            | This field is mutually exclusive with `compute`.                                                                                                                                                                                                                                                                                      |
| multi_compute             | aggregation [*required*]      | string              | The aggregation method.                                                                                                                                                                                                                                                                                                               |
| multi_compute             | facet                              | string              | Facet name.                                                                                                                                                                                                                                                                                                                           |
| multi_compute             | interval                           | int64               | Define a time interval in seconds.                                                                                                                                                                                                                                                                                                    |
| event_query               | search                             | object              | The query being made on the logs.                                                                                                                                                                                                                                                                                                     |
| search                    | query [*required*]            | string              | Search value to apply.                                                                                                                                                                                                                                                                                                                |
| requests                  | formulas                           | [object]            | List of formulas that operate on queries.                                                                                                                                                                                                                                                                                             |
| formulas                  | alias                              | string              | Expression alias.                                                                                                                                                                                                                                                                                                                     |
| formulas                  | cell_display_mode                  | enum                | Define a display mode for the table cell. Allowed enum values: `number,bar,trend`                                                                                                                                                                                                                                                     |
| formulas                  | cell_display_mode_options          | object              | Cell display mode options for the widget formula. (only if `cell_display_mode` is set to `trend`).                                                                                                                                                                                                                                    |
| cell_display_mode_options | trend_type                         | enum                | Trend type for the cell display mode options. Allowed enum values: `area,line,bars`                                                                                                                                                                                                                                                   |
| cell_display_mode_options | y_scale                            | enum                | Y scale for the cell display mode options. Allowed enum values: `shared,independent`                                                                                                                                                                                                                                                  |
| formulas                  | conditional_formats                | [object]            | List of conditional formats.                                                                                                                                                                                                                                                                                                          |
| conditional_formats       | comparator [*required*]       | enum                | Comparator to apply. Allowed enum values: `=,>,>=,<,<=`                                                                                                                                                                                                                                                                               |
| conditional_formats       | custom_bg_color                    | string              | Color palette to apply to the background, same values available as palette.                                                                                                                                                                                                                                                           |
| conditional_formats       | custom_fg_color                    | string              | Color palette to apply to the foreground, same values available as palette.                                                                                                                                                                                                                                                           |
| conditional_formats       | hide_value                         | boolean             | True hides values.                                                                                                                                                                                                                                                                                                                    |
| conditional_formats       | image_url                          | string              | Displays an image as the background.                                                                                                                                                                                                                                                                                                  |
| conditional_formats       | metric                             | string              | Metric from the request to correlate this conditional format with.                                                                                                                                                                                                                                                                    |
| conditional_formats       | palette [*required*]          | enum                | Color palette to apply. Allowed enum values: `blue,custom_bg,custom_image,custom_text,gray_on_white,grey,green,orange,red,red_on_white`                                                                                                                                                                                               |
| conditional_formats       | timeframe                          | string              | Defines the displayed timeframe.                                                                                                                                                                                                                                                                                                      |
| conditional_formats       | value [*required*]            | double              | Value for the comparator.                                                                                                                                                                                                                                                                                                             |
| formulas                  | formula [*required*]          | string              | String expression built from queries, formulas, and functions.                                                                                                                                                                                                                                                                        |
| formulas                  | limit                              | object              | Options for limiting results returned.                                                                                                                                                                                                                                                                                                |
| limit                     | count                              | int64               | Number of results to return.                                                                                                                                                                                                                                                                                                          |
| limit                     | order                              | enum                | Direction of sort. Allowed enum values: `asc,desc`                                                                                                                                                                                                                                                                                    |
| formulas                  | number_format                      | object              | Number format options for the widget.                                                                                                                                                                                                                                                                                                 |
| number_format             | unit                               |  <oneOf>       | Number format unit.                                                                                                                                                                                                                                                                                                                   |
| unit                      | Option 1                           | object              | Canonical unit.                                                                                                                                                                                                                                                                                                                       |
| unit                      | Option 2                           | object              | Custom unit.                                                                                                                                                                                                                                                                                                                          |
| number_format             | unit_scale                         | object              | The definition of `NumberFormatUnitScale` object.                                                                                                                                                                                                                                                                                     |
| unit_scale                | type                               | enum                | The type of unit scale. Allowed enum values: `canonical_unit`                                                                                                                                                                                                                                                                         |
| unit_scale                | unit_name                          | string              | The name of the unit.                                                                                                                                                                                                                                                                                                                 |
| formulas                  | style                              | object              | Styling options for widget formulas.                                                                                                                                                                                                                                                                                                  |
| style                     | palette                            | string              | The color palette used to display the formula. A guide to the available color palettes can be found at [https://docs.datadoghq.com/dashboards/guide/widget_colors](https://docs.datadoghq.com/dashboards/guide/widget_colors.md)                                                                                                      |
| style                     | palette_index                      | int64               | Index specifying which color to use within the palette.                                                                                                                                                                                                                                                                               |
| requests                  | log_query                          | object              | **DEPRECATED**: Deprecated - Use `queries` and `formulas` instead.                                                                                                                                                                                                                                                                    |
| log_query                 | compute                            | object              | Define computation for a log query.                                                                                                                                                                                                                                                                                                   |
| compute                   | aggregation [*required*]      | string              | The aggregation method.                                                                                                                                                                                                                                                                                                               |
| compute                   | facet                              | string              | Facet name.                                                                                                                                                                                                                                                                                                                           |
| compute                   | interval                           | int64               | Define a time interval in seconds.                                                                                                                                                                                                                                                                                                    |
| log_query                 | group_by                           | [object]            | List of tag prefixes to group by in the case of a cluster check.                                                                                                                                                                                                                                                                      |
| group_by                  | facet [*required*]            | string              | Facet name.                                                                                                                                                                                                                                                                                                                           |
| group_by                  | limit                              | int64               | Maximum number of items in the group.                                                                                                                                                                                                                                                                                                 |
| group_by                  | sort                               | object              | Define a sorting method.                                                                                                                                                                                                                                                                                                              |
| sort                      | aggregation [*required*]      | string              | The aggregation method.                                                                                                                                                                                                                                                                                                               |
| sort                      | facet                              | string              | Facet name.                                                                                                                                                                                                                                                                                                                           |
| sort                      | order [*required*]            | enum                | Widget sorting methods. Allowed enum values: `asc,desc`                                                                                                                                                                                                                                                                               |
| log_query                 | index                              | string              | A coma separated-list of index names. Use "*" query all indexes at once. [Multiple Indexes](https://docs.datadoghq.com/logs/indexes.md#multiple-indexes)                                                                                                                                                                              |
| log_query                 | multi_compute                      | [object]            | This field is mutually exclusive with `compute`.                                                                                                                                                                                                                                                                                      |
| multi_compute             | aggregation [*required*]      | string              | The aggregation method.                                                                                                                                                                                                                                                                                                               |
| multi_compute             | facet                              | string              | Facet name.                                                                                                                                                                                                                                                                                                                           |
| multi_compute             | interval                           | int64               | Define a time interval in seconds.                                                                                                                                                                                                                                                                                                    |
| log_query                 | search                             | object              | The query being made on the logs.                                                                                                                                                                                                                                                                                                     |
| search                    | query [*required*]            | string              | Search value to apply.                                                                                                                                                                                                                                                                                                                |
| requests                  | metadata                           | [object]            | Used to define expression aliases.                                                                                                                                                                                                                                                                                                    |
| metadata                  | alias_name                         | string              | Expression alias.                                                                                                                                                                                                                                                                                                                     |
| metadata                  | expression [*required*]       | string              | Expression name.                                                                                                                                                                                                                                                                                                                      |
| requests                  | network_query                      | object              | **DEPRECATED**: Deprecated - Use `queries` and `formulas` instead.                                                                                                                                                                                                                                                                    |
| network_query             | compute                            | object              | Define computation for a log query.                                                                                                                                                                                                                                                                                                   |
| compute                   | aggregation [*required*]      | string              | The aggregation method.                                                                                                                                                                                                                                                                                                               |
| compute                   | facet                              | string              | Facet name.                                                                                                                                                                                                                                                                                                                           |
| compute                   | interval                           | int64               | Define a time interval in seconds.                                                                                                                                                                                                                                                                                                    |
| network_query             | group_by                           | [object]            | List of tag prefixes to group by in the case of a cluster check.                                                                                                                                                                                                                                                                      |
| group_by                  | facet [*required*]            | string              | Facet name.                                                                                                                                                                                                                                                                                                                           |
| group_by                  | limit                              | int64               | Maximum number of items in the group.                                                                                                                                                                                                                                                                                                 |
| group_by                  | sort                               | object              | Define a sorting method.                                                                                                                                                                                                                                                                                                              |
| sort                      | aggregation [*required*]      | string              | The aggregation method.                                                                                                                                                                                                                                                                                                               |
| sort                      | facet                              | string              | Facet name.                                                                                                                                                                                                                                                                                                                           |
| sort                      | order [*required*]            | enum                | Widget sorting methods. Allowed enum values: `asc,desc`                                                                                                                                                                                                                                                                               |
| network_query             | index                              | string              | A coma separated-list of index names. Use "*" query all indexes at once. [Multiple Indexes](https://docs.datadoghq.com/logs/indexes.md#multiple-indexes)                                                                                                                                                                              |
| network_query             | multi_compute                      | [object]            | This field is mutually exclusive with `compute`.                                                                                                                                                                                                                                                                                      |
| multi_compute             | aggregation [*required*]      | string              | The aggregation method.                                                                                                                                                                                                                                                                                                               |
| multi_compute             | facet                              | string              | Facet name.                                                                                                                                                                                                                                                                                                                           |
| multi_compute             | interval                           | int64               | Define a time interval in seconds.                                                                                                                                                                                                                                                                                                    |
| network_query             | search                             | object              | The query being made on the logs.                                                                                                                                                                                                                                                                                                     |
| search                    | query [*required*]            | string              | Search value to apply.                                                                                                                                                                                                                                                                                                                |
| requests                  | on_right_yaxis                     | boolean             | Whether or not to display a second y-axis on the right.                                                                                                                                                                                                                                                                               |
| requests                  | process_query                      | object              | **DEPRECATED**: Deprecated - Use `queries` and `formulas` instead.                                                                                                                                                                                                                                                                    |
| process_query             | filter_by                          | [string]            | List of processes.                                                                                                                                                                                                                                                                                                                    |
| process_query             | limit                              | int64               | Max number of items in the filter list.                                                                                                                                                                                                                                                                                               |
| process_query             | metric [*required*]           | string              | Your chosen metric.                                                                                                                                                                                                                                                                                                                   |
| process_query             | search_by                          | string              | Your chosen search term.                                                                                                                                                                                                                                                                                                              |
| requests                  | profile_metrics_query              | object              | **DEPRECATED**: Deprecated - Use `queries` and `formulas` instead.                                                                                                                                                                                                                                                                    |
| profile_metrics_query     | compute                            | object              | Define computation for a log query.                                                                                                                                                                                                                                                                                                   |
| compute                   | aggregation [*required*]      | string              | The aggregation method.                                                                                                                                                                                                                                                                                                               |
| compute                   | facet                              | string              | Facet name.                                                                                                                                                                                                                                                                                                                           |
| compute                   | interval                           | int64               | Define a time interval in seconds.                                                                                                                                                                                                                                                                                                    |
| profile_metrics_query     | group_by                           | [object]            | List of tag prefixes to group by in the case of a cluster check.                                                                                                                                                                                                                                                                      |
| group_by                  | facet [*required*]            | string              | Facet name.                                                                                                                                                                                                                                                                                                                           |
| group_by                  | limit                              | int64               | Maximum number of items in the group.                                                                                                                                                                                                                                                                                                 |
| group_by                  | sort                               | object              | Define a sorting method.                                                                                                                                                                                                                                                                                                              |
| sort                      | aggregation [*required*]      | string              | The aggregation method.                                                                                                                                                                                                                                                                                                               |
| sort                      | facet                              | string              | Facet name.                                                                                                                                                                                                                                                                                                                           |
| sort                      | order [*required*]            | enum                | Widget sorting methods. Allowed enum values: `asc,desc`                                                                                                                                                                                                                                                                               |
| profile_metrics_query     | index                              | string              | A coma separated-list of index names. Use "*" query all indexes at once. [Multiple Indexes](https://docs.datadoghq.com/logs/indexes.md#multiple-indexes)                                                                                                                                                                              |
| profile_metrics_query     | multi_compute                      | [object]            | This field is mutually exclusive with `compute`.                                                                                                                                                                                                                                                                                      |
| multi_compute             | aggregation [*required*]      | string              | The aggregation method.                                                                                                                                                                                                                                                                                                               |
| multi_compute             | facet                              | string              | Facet name.                                                                                                                                                                                                                                                                                                                           |
| multi_compute             | interval                           | int64               | Define a time interval in seconds.                                                                                                                                                                                                                                                                                                    |
| profile_metrics_query     | search                             | object              | The query being made on the logs.                                                                                                                                                                                                                                                                                                     |
| search                    | query [*required*]            | string              | Search value to apply.                                                                                                                                                                                                                                                                                                                |
| requests                  | q                                  | string              | **DEPRECATED**: Widget query. Deprecated - Use `queries` and `formulas` instead.                                                                                                                                                                                                                                                      |
| requests                  | queries                            | [ <oneOf>]     | List of queries that can be returned directly or used in formulas.                                                                                                                                                                                                                                                                    |
| queries                   | Option 1                           | object              | A formula and functions metrics query.                                                                                                                                                                                                                                                                                                |
| Option 1                  | aggregator                         | enum                | The aggregation methods available for metrics queries. Allowed enum values: `avg,min,max,sum,last,area,l2norm,percentile`                                                                                                                                                                                                             |
| Option 1                  | cross_org_uuids                    | [string]            | The source organization UUID for cross organization queries. Feature in Private Beta.                                                                                                                                                                                                                                                 |
| Option 1                  | data_source [*required*]      | enum                | Data source for metrics queries. Allowed enum values: `metrics`                                                                                                                                                                                                                                                                       |
| Option 1                  | name [*required*]             | string              | Name of the query for use in formulas.                                                                                                                                                                                                                                                                                                |
| Option 1                  | query [*required*]            | string              | Metrics query definition.                                                                                                                                                                                                                                                                                                             |
| Option 1                  | semantic_mode                      | enum                | Semantic mode for metrics queries. This determines how metrics from different sources are combined or displayed. Allowed enum values: `combined,native`                                                                                                                                                                               |
| queries                   | Option 2                           | object              | A formula and functions events query.                                                                                                                                                                                                                                                                                                 |
| Option 2                  | compute [*required*]          | object              | Compute options.                                                                                                                                                                                                                                                                                                                      |
| compute                   | aggregation [*required*]      | enum                | Aggregation methods for event platform queries. Allowed enum values: `count,cardinality,median,pc75,pc90,pc95,pc98,pc99,sum,min`                                                                                                                                                                                                      |
| compute                   | interval                           | int64               | A time interval in milliseconds.                                                                                                                                                                                                                                                                                                      |
| compute                   | metric                             | string              | Measurable attribute to compute.                                                                                                                                                                                                                                                                                                      |
| Option 2                  | cross_org_uuids                    | [string]            | The source organization UUID for cross organization queries. Feature in Private Beta.                                                                                                                                                                                                                                                 |
| Option 2                  | data_source [*required*]      | enum                | Data source for event platform-based queries. Allowed enum values: `logs,spans,network,rum,security_signals,profiles,audit,events,ci_tests,ci_pipelines`                                                                                                                                                                              |
| Option 2                  | group_by                           |  <oneOf>       | Group by configuration for a formula and functions events query. Accepts either a list of facet objects or a flat object that specifies a list of facet fields.                                                                                                                                                                       |
| group_by                  | Option 1                           | [object]            | List of objects used to group by.                                                                                                                                                                                                                                                                                                     |
| group_by                  | Option 2                           | object              | Flat group by configuration using multiple event facet fields.                                                                                                                                                                                                                                                                        |
| Option 2                  | indexes                            | [string]            | An array of index names to query in the stream. Omit or use `[]` to query all indexes at once.                                                                                                                                                                                                                                        |
| Option 2                  | name [*required*]             | string              | Name of the query for use in formulas.                                                                                                                                                                                                                                                                                                |
| Option 2                  | search                             | object              | Search options.                                                                                                                                                                                                                                                                                                                       |
| search                    | query [*required*]            | string              | Events search string.                                                                                                                                                                                                                                                                                                                 |
| Option 2                  | storage                            | string              | Option for storage location. Feature in Private Beta.                                                                                                                                                                                                                                                                                 |
| queries                   | Option 3                           | object              | Process query using formulas and functions.                                                                                                                                                                                                                                                                                           |
| Option 3                  | aggregator                         | enum                | The aggregation methods available for metrics queries. Allowed enum values: `avg,min,max,sum,last,area,l2norm,percentile`                                                                                                                                                                                                             |
| Option 3                  | cross_org_uuids                    | [string]            | The source organization UUID for cross organization queries. Feature in Private Beta.                                                                                                                                                                                                                                                 |
| Option 3                  | data_source [*required*]      | enum                | Data sources that rely on the process backend. Allowed enum values: `process,container`                                                                                                                                                                                                                                               |
| Option 3                  | is_normalized_cpu                  | boolean             | Whether to normalize the CPU percentages.                                                                                                                                                                                                                                                                                             |
| Option 3                  | limit                              | int64               | Number of hits to return.                                                                                                                                                                                                                                                                                                             |
| Option 3                  | metric [*required*]           | string              | Process metric name.                                                                                                                                                                                                                                                                                                                  |
| Option 3                  | name [*required*]             | string              | Name of query for use in formulas.                                                                                                                                                                                                                                                                                                    |
| Option 3                  | sort                               | enum                | Direction of sort. Allowed enum values: `asc,desc`                                                                                                                                                                                                                                                                                    |
| Option 3                  | tag_filters                        | [string]            | An array of tags to filter by.                                                                                                                                                                                                                                                                                                        |
| Option 3                  | text_filter                        | string              | Text to use as filter.                                                                                                                                                                                                                                                                                                                |
| queries                   | Option 4                           | object              | A formula and functions APM dependency stats query.                                                                                                                                                                                                                                                                                   |
| Option 4                  | cross_org_uuids                    | [string]            | The source organization UUID for cross organization queries. Feature in Private Beta.                                                                                                                                                                                                                                                 |
| Option 4                  | data_source [*required*]      | enum                | Data source for APM dependency stats queries. Allowed enum values: `apm_dependency_stats`                                                                                                                                                                                                                                             |
| Option 4                  | env [*required*]              | string              | APM environment.                                                                                                                                                                                                                                                                                                                      |
| Option 4                  | is_upstream                        | boolean             | Determines whether stats for upstream or downstream dependencies should be queried.                                                                                                                                                                                                                                                   |
| Option 4                  | name [*required*]             | string              | Name of query to use in formulas.                                                                                                                                                                                                                                                                                                     |
| Option 4                  | operation_name [*required*]   | string              | Name of operation on service.                                                                                                                                                                                                                                                                                                         |
[...]
